import api from '@/api'
import { Page } from '@/api/queries'


export default {
  state: {
    welcome: undefined,
    intro: undefined,
    kit: undefined,
    ids: {
      welcome: 263,
      intro: 264,
      kit: 265
    },
    visited: localStorage.getItem('visited') === 'true'
  },

  mutations: {
    'SET_PAGE' (state, { slug, page }) {
      state[slug] = page
    },

    'SET_VISITED' (state, visited) {
      state.visited = visited
      localStorage.setItem('visited', visited)
    }
  },

  actions: {
    async 'QUERY_PAGE' ({ state, commit, dispatch, getters }, slug) {
      if (state[slug] !== undefined) return state[slug]
      return api.query(Page, { id: state.ids[slug] }).then(data => {
        commit('SET_PAGE', { slug, page: data.page })
        return state[slug]
      })
    }
  },

  getters: {
    visited: state => state.visited
  }
}
